﻿
using ProjectByldozerHard.Entities;

namespace ProjectByldozerHard.Drawing;

public class DrawningByldozer : DrawningTrackedCar
{
	private InterDopRink? DrawingKatki;

    /// <summary>
    /// конструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="dump">Признак наличия отвала</param>
    /// <param name="bakingpowder">Признак наличия разрыхлитель</param>
    /// <param name="pipe">Признак наличия трубы</param>
    public DrawningByldozer(int speed, double weight, Color bodyColor, Color additionalColor, bool dump, bool bakingpowder, bool pipe,
        bool katki, int width, int height, int numKatki, int numchoose) : base(speed, weight, bodyColor, width, height, numKatki, numchoose)
    {
        if (EntityTrackedCar != null)
        {
            EntityTrackedCar = new EntityByldozer(speed, weight, bodyColor, additionalColor, dump, bakingpowder, pipe, katki);
        }
        int choose = numchoose % 3;
        switch (choose)
        {
            case 0:
                DrawingKatki = new DrawingRinkSquare();
                break;
            case 1:
                DrawingKatki = new DrawingRinkTriagle();
                break;
            case 2:
                DrawingKatki = new DrawingRinkCircule();
                break;
        }
        DrawingKatki.Properties = numKatki;
    }



    public override void DrawTransport(Graphics g)
    {
        if (EntityTrackedCar is not EntityByldozer entityByldozer)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(EntityByldozer.AdditionalColor);
        Brush bodybrush = new SolidBrush(EntityTrackedCar.BodyColor);

        base.DrawTransport(g);
        ///труба
        if (entityByldozer.Pipe)
        {
            g.DrawRectangle(pen, _startPosX + 60, _startPosY, 5, 15);
            g.FillRectangle(bodybrush, _startPosX + 60, _startPosY, 5, 15);
        }
        _startPosX -= 30;
        _startPosY -= 5;
        // отвал
        if (entityByldozer.Dump)

        {
            Point point1 = new Point(_startPosX + 30, _startPosY + 35);
            Point point2 = new Point(_startPosX + 25, _startPosY + 35);
            Point point4 = new Point(_startPosX + 25, _startPosY + 23);
            Point point5 = new Point(_startPosX + 20, _startPosY + 23);
            Point point6 = new Point(_startPosX + 15, _startPosY + 60);
            Point point7 = new Point(_startPosX + 2, _startPosY + 80);
            Point point8 = new Point(_startPosX + 25, _startPosY + 80);
            Point point9 = new Point(_startPosX + 25, _startPosY + 46);
            Point point10 = new Point(_startPosX + 30, _startPosY + 46);

            Point[] Dump = { point1, point2, point4, point5, point6, point7, point8, point9, point10 };
            g.FillPolygon(additionalBrush, Dump);
        }

        if (entityByldozer.Bakingpowder)

        {
            Point point1 = new Point(_startPosX + 131, _startPosY + 25);
            Point point2 = new Point(_startPosX + 150, _startPosY + 25);
            Point point4 = new Point(_startPosX + 150, _startPosY + 35);
            Point point5 = new Point(_startPosX + 147, _startPosY + 35);
            Point point6 = new Point(_startPosX + 147, _startPosY + 60);
            Point point7 = new Point(_startPosX + 144, _startPosY + 60);
            Point point8 = new Point(_startPosX + 145, _startPosY  + 80);
            Point point9 = new Point(_startPosX + 137, _startPosY + 60);
            Point point10 = new Point(_startPosX + 134, _startPosY + 60);
            Point point11 = new Point(_startPosX + 134, _startPosY + 35);

            Point point12 = new Point(_startPosX + 131, _startPosY + 35);


            Point[] Bakingpowder = { point1, point2, point4, point5, point6, point7, point8, point9, point10, point11, point12 };
            g.FillPolygon(additionalBrush, Bakingpowder);

        }
    }
}
